<template>
       <b-card class="animated fadeIn">
         <div slot="header">
                <span class="custom-card-title">Danh sách người dùng</span>
               <b-button variant="primary" class="float-right" to="/users/create"><i class="fa fa-plus"></i> Tạo mới</b-button>
           </div>
        <b-row>
            <b-col md="3" class="my-1">
                <b-form-group horizontal label="Hiển thị">
                    <b-form-select :options="pageOptions" v-model="perPage" />
                </b-form-group>
            </b-col>
        </b-row>
      <b-table striped hover 
               :items="users" 
               :fields="fields"
               :current-page="currentPage"
               :per-page="perPage">
        <span slot="status_label" slot-scope="data" v-html="data.value"></span>
        <template slot="roles" slot-scope="row">
            <div v-for="role in row.item.roles" :key="role.id">
                <span>{{ role.description }}</span>
            </div>
        </template>
        <template slot="actions" slot-scope="row">
        <!-- <b-button size="sm" variant="success" :to="{ name: 'Cập nhật nhân viên', params: { saleId: row.item.id}}">Edit</b-button> -->
       <b-button size="sm" :variant="row.item.status == 2 ? 'warning' : 'danger'" @click.stop="confirmAction(row.item)">{{ row.item.status == 2 ? 'Active' : 'Deactive' }}</b-button>
      </template>       
      </b-table>
          <b-row>
      <b-col md="6" class="my-1">
        <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
      </b-col>
    </b-row>
       </b-card>

</template>

<script>
import { http } from "../../services";
import { alerts } from "../../utils";
export default {
  data() {
    return {
      fields: [
        {
          key: "id",
          label: "ID",
          sortable: true
        },
        {
          key: "name",
          label: "Họ tên",
          sortable: true
        },
        {
          key: "roles",
          label: "Quyền hạn",
          sortable: true
        },
        {
          key: "email",
          label: "Email",
          sortable: true
        },
        {
          key: "status_label",
          label: "Trạng thái",
          sortable: true
        },
        {
          key: "created_at",
          label: "Ngày tạo",
          sortable: true,
          formatter: value => {
            return this.$moment(value).format("DD/MM/YYYY HH:mm:ss");
          }
        },
        {
          key: "actions",
          label: "Actions"
        }
      ],
      users: [],
      selectedUser: null,
      currentPage: 1,
      perPage: 5,
      totalRows: 0,
      pageOptions: [5, 10, 15]
    };
  },
  created() {
    this.fetchUsers();
  },
  methods: {
    fetchUsers() {
      http.get("/user", response => {
        this.users = response.data;
        this.totalRows = response.data.length;
      });
    },
    async toggleActiveState() {
      return new Promise((resolve, reject) => {
        http.post(
          "/user/toggleActive",
          { id: this.selectedUser.id },
          response => {
            //console.log(response.data)
            return resolve(response.data);
          }
        );
      });
    },
    confirmAction(user) {
      this.selectedUser = user;
      let msg = "Bạn chắc chắn muốn khóa tài khoản này?";
      if (user.status == 2) {
        msg = "Bạn chắc chắn muốn kích hoạt tài khoản này?";
      }
      alerts.ajaxConfirm(
        msg,
        "warning",
        this.toggleActiveState,
        this.fetchUsers
      );
    }
  }
};
</script>
<style>
</style>
